import { PaginationResponse } from 'src/core/response/domain/ok-response.interface';
import { BaseReadManager } from '../base-read.manager';
import { SelectQueryBuilder } from 'typeorm';
import {
  Param,
  SpecificSearchFilter,
} from 'src/core/helpers/query/specific-search.helper';

export abstract class BaseIndexManager<Entity> extends BaseReadManager {
  protected result: PaginationResponse<Entity>;
  public filterParam: any;
  abstract get specificFilter(): Param[];

  setFilterParam(param: any): void {
    this.filterParam = param;
  }

  async process(): Promise<void> {
    // const filterSearch: string[] = this.setFilterSearch();

    // this.queryBuilder.andWhere(
    //   new Brackets((qb) => {
    //     filterSearch.map((fSearch) => {
    //       qb.orWhere(`${fSearch} ILIKE :query`, {
    //         query: `%${
    //           this.filterParam.q.trim().replace(/\s+/g, ' ') ?? ''
    //         }%`,
    //       });
    //     });
    //   }),
    // );

    // new SpecificSearchFilter<Entity>(
    //   this.queryBuilder,
    //   this.tableName,
    //   this.specificFilter,
    // ).getFilter();
    this.setQueryFilter(this.queryBuilder);

    this.result = await this.dataService.getIndex(
      this.queryBuilder,
      this.filterParam,
    );
  }

  setFilterSearch(): string[] {
    return [];
  }

  abstract setQueryFilter(
    queryBuilder: SelectQueryBuilder<Entity>,
  ): SelectQueryBuilder<Entity>;

  getResult(): PaginationResponse<Entity> {
    return this.result;
  }
}
